
%%Maak excel bestand
filename = 'mean_absolutedeviation_all.xls';
resultFileHeader = {'pp','C1_blindfold', 'C1_direction', 'C1_T1', 'C1_T2', 'C1_T3', 'C1_T4', 'C1_T5', 'C1_T6', 'C2_blindfold', 'C2_direction', 'C2_T1', 'C2_T2', 'C2_T3', 'C2_T4', 'C2_T5', 'C2_T6', 'extraAttemptsC1', 'extraAttemptsC2'};
xlswrite(filename, resultFileHeader, 'Sheet1', 'A1');

%%tel aantal samples om guided radius array aan te vullen op juiste locatie 
%%(enkel buiten file loop op nul omdat ALLE guided radiussen er in moeten)
guidedCounter = 0;

%%loop door alle text files in folder een eerste keer om error correctie op guided traject te berekenen
dirListing = dir ('*.txt');
for j=1:size(dirListing,1)
    
    %%open text file
    fid = fopen(dirListing(j).name);
    C = textscan(fid, '%s %f %f %s %s %s %s %f %f %f %f %f %f %f %f %f %f %f','Delimiter',';');
    fclose(fid);

    %%haal phase, mode en radius op
    phase = C{1,6};
    mode = C{1,7};
    radius = C{1,15};

    %% loop door alle samples om radius guided samples van deze file in array te steken
    for i=1:length(radius)
        if (phase(i) == "test")           
            if (mode(i) == "Guided")
                guidedCounter = guidedCounter + 1;
                guidedRadius(guidedCounter) = radius(i);
            end
        end
    end
end

%%bereken gemiddelde guided radius over alle samples van het experiment
meanGuidedRadius = mean(guidedRadius);
clear guidedRadius;

%%loop door alle text files in folder een tweede keer om absolute gemiddelde afwijking per trial te berekenen
for j=1:size(dirListing,1)
        
    %%open text file
    fid = fopen(dirListing(j).name);
    C = textscan(fid, '%s %f %f %s %s %s %s %f %f %f %f %f %f %f %f %f %f %f','Delimiter',';');
    fclose(fid);

    %%haal trialnumber, condition, blindfold, direction, phase, mode, attempt en radius op
    trialNumberstr = C{1,1};
    condition = C{1,3};
    blindfold = C{1,4};
    direction = C{1,5};
    phase = C{1,6};
    mode = C{1,7};
    attempt = C{1,8};
    xPos = C{1,12};
    yPos = C{1,14};
    radius = C{1,15};

    %%maak matrix om eigenschappen condities (leeg), resultaten (gevuld met nullen), en #extra guided pogingen per conditie (nullen) op te slaan
    featuresC1 = [""; ""];
    resultsC1 = zeros(6,1,'double');
    attemptsC1 = zeros(1,1,'double');
    featuresC2 = [""; ""];
    resultsC2 = zeros(6,1,'double');
    attemptsC2 = zeros(1,1,'double');
    
    %%maak trialNumber (double) obv trialNumberstr (string) & schrijf start en eindposities van free movement weg 
    trialCounter = 1;

    for i=1:size(trialNumberstr)
        if (i ~= size(trialNumberstr))
            trialNumber(i) = trialCounter;
            if (mode(i) == "Free") && (mode(i-1) == "Guided")
                startxPos(trialCounter) = xPos(i);
                startyPos(trialCounter) = yPos(i);
            end
            if (strcmp(trialNumberstr(i + 1),trialNumberstr(i)) == 0)    %%volgende sample behoort tot volgende trial
                endxPos(trialCounter) = xPos(i);
                endyPos(trialCounter) = yPos(i);
                trialCounter = trialCounter + 1;
            end
        else                                                    %%einde file bereikt
            trialNumber(i) = trialCounter;
            endxPos(trialCounter) = xPos(i);     
            endyPos(trialCounter) = yPos(i);   
        end
    end
    
    %%tel aantal samples om error array aan te vullen op juiste locatie (per trial)
    errorCounter = 0;
    extraAttemptCounter = 0;                                    %%extraAttemptCounter opnieuw op nul zetten voor nieuwe loop begint
    startSavingError = 0;                                       %%errors rond startpositie niet meetellen om gewicht late reactietijd weg te nemen
    
    %%loop door alle samples om gemiddelde absolute afwijking per trial te berekenen (GEBRUIKT CORRECTIE OVER ALLE TRIALS EN PROEFPERSONEN)
    for i=1:length(trialNumber)
        if (phase(i) == "test")
            if (condition(i) == 1)
                if (mode(i) == "Guided") && (i ~= 1) && (attempt(i) > attempt (i-1))    %%tel aantal pogingen op guided test circle; i mag niet 1 zijn omwille van vergelijking, vergelijking klopt ook voor trials anders dan trial 1    
                    extraAttemptCounter = extraAttemptCounter + 1;
                end
                if (mode(i) == "Free") && (startSavingError == 0) && ((xPos(i) > (startxPos(trialNumber(i)) + 0.03)) || (yPos(i) > (startyPos(trialNumber(i)) + 0.03)) || (xPos(i) < (startxPos(trialNumber(i)) - 0.03)) || (yPos(i) < (startyPos(trialNumber(i)) - 0.03)))
                    startSavingError = 1;                       %%begin met opslaan errors buiten straal van 0.03 vanaf beginpositie
                end               
                if (mode(i) == "Free") && (startSavingError == 1)                        
                    errorCounter = errorCounter + 1;                       
                    error(errorCounter) = abs(radius(i) - meanGuidedRadius);                    
                end                
                if (trialNumber(i+1) > trialNumber(i))          %%laatste waarde van trial, dus resultaten wegschrijven                        
                    initialLengthError = length(error);         %%initile lengte vastleggen want zal veranderen in loop
                    for k=i:-1:(i-length(error))                %%verwijder errors binnen straal van 0.03 vanaf eindpositie
                        if (xPos(k) > (endxPos(trialNumber(k)) + 0.03)) || (yPos(k) > (endyPos(trialNumber(k)) + 0.03)) || (xPos(k) < (endxPos(trialNumber(k)) - 0.03)) || (yPos(k) < (endyPos(trialNumber(k)) - 0.03))
                            break;
                        else
                            error(initialLengthError - (i - k)) = [];
                        end
                    end
                    featuresC1(1) = blindfold(i);                        
                    featuresC1(2) = direction(i);                        
                    resultsC1(trialNumber(i)-3) = mean(error);  %%eerste 3 trials van conditie 1 zijn practice                       
                    %%break;
                    clear error;                                %%gemiddelde error wordt per trial berekend                       
                    errorCounter = 0; 
                    startSavingError = 0;
                    if (trialNumber(i) == 9)                    %%laatste trial conditie, dus extra guided pogingen wegschrijven; aantal pogingen wordt per conditie geteld                            
                        attemptsC1(1) = extraAttemptCounter;        
                        extraAttemptCounter = 0;                         
                    end
                end
            else
                if (mode(i) == "Guided") && (attempt(i) > attempt (i-1))    %%tel aantal pogingen op guided test cirkel    
                    extraAttemptCounter = extraAttemptCounter + 1;
                end
                if (mode(i) == "Free") && (startSavingError == 0) && (((xPos(i) > startxPos(trialNumber(i)) + 0.03)) || ((yPos(i) > startyPos(trialNumber(i)) + 0.03)) || (xPos(i) < (startxPos(trialNumber(i)) - 0.03)) || (yPos(i) < (startyPos(trialNumber(i)) - 0.03)))
                    startSavingError = 1;                       %%begin met opslaan errors buiten straal van 0.03 vanaf beginpositie
                end  
                if (i ~= length(trialNumber)) && (trialNumber(i+1) == trialNumber(i)) && (startSavingError == 1) && (mode(i) == "Free")    %%i mag niet maximale waarden hebben voor vergelijking
                    errorCounter = errorCounter + 1;
                    error(errorCounter) = abs(radius(i) - meanGuidedRadius); 
                elseif (startSavingError == 1) && (mode(i) ~= "Guided")     %%laatste waarde trial, dus wegschrijven
                    errorCounter = errorCounter + 1;            
                    error(errorCounter) = abs(radius(i) - meanGuidedRadius);%%laatste waarde ook nog wegschrijven
                    initialLengthError = length(error);         %%initile lengte vastleggen want zal veranderen in loop
                    for k=i:-1:(i-length(error))                %%verwijder errors binnen straal van 0.03 vanaf eindpositie
                        if (xPos(k) > (endxPos(trialNumber(k)) + 0.03)) || (yPos(k) > (endyPos(trialNumber(k)) + 0.03)) || (xPos(k) < (endxPos(trialNumber(k)) - 0.03)) || (yPos(k) < (endyPos(trialNumber(k)) - 0.03))
                            break;
                        else
                            error(initialLengthError - (i - k)) = [];
                        end
                    end
                    featuresC2(1) = blindfold(i);
                    featuresC2(2) = direction(i);
                    resultsC2(trialNumber(i)-12) = mean(error); %%eerste 3 trials van conditie 1 en eerste 3 van conditie 2 zijn practice
                    clear error;
                    errorCounter = 0;
                    startSavingError = 0;
                    if (trialNumber(i) == 18)                   %%laatste trial conditie, dus extra guided pogingen wegschrijven; aantal pogingen wordt per conditie geteld
                        attemptsC2(1) = extraAttemptCounter;
                        extraAttemptCounter = 0;               
                    end
                end 
            end 
        end    
    end
        
    clear trialNumber;
    clear startxPos;
    clear startyPos;
    clear endxPos;
    clear endyPos;
    
    %%wegschijven naar Excel bestand
    xlswrite(filename, j, 'Sheet1', "A" + (j + 1));
    xlswrite(filename, featuresC1', 'Sheet1', "B" + (j + 1));
    xlswrite(filename, resultsC1', 'Sheet1', "D" + (j + 1));
    xlswrite(filename, featuresC2', 'Sheet1', "J" + (j + 1));
    xlswrite(filename, resultsC2', 'Sheet1', "L" + (j + 1));
    xlswrite(filename, attemptsC1', 'Sheet1', "R" + (j + 1));
    xlswrite(filename, attemptsC2', 'Sheet1', "S" + (j + 1));
end